#version 330 core

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

in vec4 plane;
out vec4 ex_color;
out vec2 ex_screen;

void main(void)

{
	vec4 tmp_plane = plane;
	tmp_plane.xyz = (tmp_plane.xyz-vec3(0.5,0.5,0.5)) * vec3(2.0, 2.0, 2.0);
	tmp_plane.xyz +=  vec3(0.0, 0.8, 0.0);
	gl_Position = perspective * view * model * tmp_plane;
	
	ex_screen = gl_Position.xy / gl_Position.w;
	ex_screen = (ex_screen + vec2(1.0, 1.0))/vec2(2.0, 2.0);
//ex_screen.y = 1.0 - ex_screen.y;

	ex_color = tmp_plane;
	ex_color.w = 1.0;

	if(plane.y > 0.0)	ex_color = vec4(0.0, 0.0, 0.0, 1.0);
	else		ex_color = vec4(0.0, 0.0, 0.0, 0.0);
}