#version 330 core
precision mediump float;

// uniform shader-parameters
uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

// vertex-shader input variables
in vec4 vertex;
in vec4 color;

// vertex-shader output variables (passed to fragment-shader)
out vec4 frag_color;

void main()
{    	
	// just pass color to fragment-shader
	frag_color = color;

	// transform vertex down the pipeline
	gl_Position = perspective * view * model * vertex;
}