#version 330 core

// uniform shader-parameters
uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

// vertex-shader input variables
in vec4 vertex;
in vec4 tex_coord;

// vertex-shader output variables (passed to fragment-shader)
out vec2 ex_texcoord;

void main()
{    	
	// just pass color to fragment-shader
	ex_texcoord = tex_coord.st;

	// transform vertex down the pipeline
	gl_Position = perspective * view * model * vertex;
}