#version 330 core  
precision mediump float;

// sampler holding texture data
uniform int transfer;
uniform int mip;
uniform int average;
uniform int light;
uniform int phong;
uniform int adaptive;
uniform float stepSize;
uniform sampler2D entryTexture;
uniform sampler2D exitTexture;
uniform sampler3D colorTexture;
uniform sampler3D pcdTexture;
uniform sampler2D transferTexture;
uniform sampler1D tex_hg;
uniform sampler1D tex_hg_dev;

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

// fragment-shader input variables
in vec2 fragTexCoordVolume;

// fragment-shader output variable (-> stored in the frame-buffer, i.e. "the pixel you see")
out vec4 out_color;


//ZUGRIFF: texture(pcdTexture, point)

vec4 lerp(vec4 b, vec4 a, float w)
{
//  return a + w*(b-a);	
	return (a*(1.0-w)) + (w*b);
}
vec3 lerp(vec3 b, vec3 a, float w)
{
//  return a + w*(b-a);
	return (a*(1.0-w)) + (w*b);
}
vec2 lerp(vec2 b, vec2 a, float w)
{
// return a + w*(b-a);
return (a*(1.0-w)) + (w*b);
}
float lerp(float b, float a, float w)
{
//  return a + w*(b-a);
return (a*(1.0-w)) + (w*b);
}

/*mat3 calcHesse2(vec3 coord, vec3 size_source)
{
	//Gradienten durch Aufruf von calculateVoxel
	dz = 1.0/128.0;

	vec3 sample1 = vec3(0.0, 0.0, 0.0);
	vec3 sample2 = vec3(0.0, 0.0, 0.0);

	sample1.x = texture(colorTexture, point.xyz - vec3(dz, 0, 0));
	sample1.y = texture(colorTexture, point.xyz - vec3(0, dz, 0));
	sample1.z = texture(colorTexture, point.xyz - vec3(0, 0, dz));

	sample2.x = texture(colorTexture, point.xyz + vec3(dz, 0, 0));
	sample2.y = texture(colorTexture, point.xyz + vec3(0, dz, 0));
	sample2.z = texture(colorTexture, point.xyz + vec3(0, 0, dz));
	
	vec3 sample = sample2 - sample1;


	
	return N;
}*/

mat3 calcHesse(vec3 coord, vec3 size_source)
{
	float h = 0.0;

	//vec3 coord_hg = (coord) - (vec3(0.5f, 0.5f, 0.5f)/size_source);
	//vec3 coord_hg = (coord) + (vec3(0.5f, 0.5f, 0.5f)/size_source);
	//vec3 coord_hg = (coord*size_source) - vec3(0.5f, 0.5f, 0.5f);
	vec3 coord_hg = (coord) + (vec3(0.5f, 0.5f, 0.5f)/size_source);

	// fetch offsets and weights from filter texture
	vec4 hg_x = texture( tex_hg, coord_hg.x);
	vec4 hg_y = texture( tex_hg, coord_hg.y);
	vec4 hg_z = texture( tex_hg, coord_hg.z);

	vec4 hg_x_dev = texture( tex_hg_dev, coord_hg.x);
	vec4 hg_y_dev = texture( tex_hg_dev, coord_hg.y);
	vec4 hg_z_dev = texture( tex_hg_dev, coord_hg.z);


	float xx = 0.0;
	float yy = 0.0;
	float zz = 0.0;
	float xy = 0.0;
	float xz = 0.0;
	float yz = 0.0;


	//__________________________
	//Hesse xx
	vec3 mlf_tc = coord - vec3(0.0, (hg_y.x/size_source.y), 0.0);
	vec3 muf_tc = coord + vec3(0.0, (hg_y.y/size_source.y), 0.0);
              
	vec3 mln_tc = mlf_tc - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	vec3 mun_tc = muf_tc - vec3(0.0, 0.0, (hg_z.x/size_source.z));
		 mlf_tc = mlf_tc + vec3(0.0, 0.0, (hg_z.y/size_source.z));
		 muf_tc = muf_tc + vec3(0.0, 0.0, (hg_z.y/size_source.z));
	
	vec3 lln_tc = mln_tc - vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 lun_tc = mun_tc - vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 llf_tc = mlf_tc - vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 luf_tc = muf_tc - vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 rln_tc = mln_tc + vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 run_tc = mun_tc + vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 rlf_tc = mlf_tc + vec3((1.0/size_source.x), 0.0, 0.0);
	vec3 ruf_tc = muf_tc + vec3((1.0/size_source.x), 0.0, 0.0);

	//ab da sollte es wieder stimmen
	// fetch four linearly interpolated inputs
	vec4 r_val = vec4(0.0);
	vec4 m_val = vec4(0.0);
	vec4 l_val = vec4(0.0);
	vec4 f_val = vec4(0.0);
	vec4 n_val = vec4(0.0);
	l_val.x = texture( colorTexture, lln_tc).w;
	l_val.y = texture( colorTexture, lun_tc).w;
	l_val.z = texture( colorTexture, llf_tc).w;
	l_val.w = texture( colorTexture, luf_tc).w;
	
	m_val.x = texture( colorTexture, mln_tc).w;
	m_val.y = texture( colorTexture, mun_tc).w;
	m_val.z = texture( colorTexture, mlf_tc).w;
	m_val.w = texture( colorTexture, muf_tc).w;

	r_val.x = texture( colorTexture, rln_tc).w;
	r_val.y = texture( colorTexture, run_tc).w;
	r_val.z = texture( colorTexture, rlf_tc).w;
	r_val.w = texture( colorTexture, ruf_tc).w;

	l_val.zw = lerp(l_val.xy, l_val.zw, hg_z.z);    
	m_val.zw = lerp(m_val.xy, m_val.zw, hg_z.z);
	r_val.zw = lerp(r_val.xy, r_val.zw, hg_z.z);

	l_val.x = lerp(l_val.z, l_val.w, hg_y.z);
	l_val.y = lerp(m_val.z, m_val.w, hg_y.z);
	l_val.z = lerp(r_val.z, r_val.w, hg_y.z);
	xx = dot(l_val.xyz, vec3(1.0,-2.0,1.0));

	
	
	mlf_tc = vec3(0.0);
	muf_tc = vec3(0.0);
	mln_tc = vec3(0.0);
	mun_tc = vec3(0.0);

	//__________________________
	//Hesse yy
	// left/right upper/lower near/far
	r_val = vec4(0.0);
	m_val = vec4(0.0);
	l_val = vec4(0.0);
	f_val = vec4(0.0);
	n_val = vec4(0.0);

	vec3 lmf_tc = coord - vec3((hg_x.x/size_source.x), 0.0, 0.0);
	vec3 rmf_tc = coord + vec3((hg_x.y/size_source.x), 0.0, 0.0);
              
	vec3 lmn_tc = lmf_tc - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	vec3 rmn_tc = rmf_tc - vec3(0.0, 0.0, (hg_z.x/size_source.z));
		 lmf_tc = lmf_tc + vec3(0.0, 0.0, (hg_z.y/size_source.z));
		 rmf_tc = rmf_tc + vec3(0.0, 0.0, (hg_z.y/size_source.z));

	lln_tc = lmn_tc - vec3(0.0, (1.0/size_source.y), 0.0);
	rln_tc = rmn_tc - vec3(0.0, (1.0/size_source.y), 0.0);
	llf_tc = lmf_tc - vec3(0.0, (1.0/size_source.y), 0.0);
	rlf_tc = rmf_tc - vec3(0.0, (1.0/size_source.y), 0.0);
	lun_tc = lmn_tc + vec3(0.0, (1.0/size_source.y), 0.0);
	run_tc = rmn_tc + vec3(0.0, (1.0/size_source.y), 0.0);
	luf_tc = lmf_tc + vec3(0.0, (1.0/size_source.y), 0.0);
	ruf_tc = rmf_tc + vec3(0.0, (1.0/size_source.y), 0.0);

	l_val.x = texture( colorTexture, lln_tc).w;
	l_val.y = texture( colorTexture, rln_tc).w;
	l_val.z = texture( colorTexture, llf_tc).w;
	l_val.w = texture( colorTexture, rlf_tc).w;
	
	m_val.x = texture( colorTexture, lmn_tc).w;
	m_val.y = texture( colorTexture, rmn_tc).w;
	m_val.z = texture( colorTexture, lmf_tc).w;
	m_val.w = texture( colorTexture, rmf_tc).w;
	
	r_val.x = texture( colorTexture, lun_tc).w;
	r_val.y = texture( colorTexture, run_tc).w;
	r_val.z = texture( colorTexture, luf_tc).w;
	r_val.w = texture( colorTexture, ruf_tc).w;

	l_val.zw = lerp(l_val.xy, l_val.zw, hg_z.z);
	m_val.zw = lerp(m_val.xy, m_val.zw, hg_z.z);
	r_val.zw = lerp(r_val.xy, r_val.zw, hg_z.z);

	l_val.x = lerp(l_val.z, l_val.w, hg_x.z);
	l_val.y = lerp(m_val.z, m_val.w, hg_x.z);
	l_val.z = lerp(r_val.z, r_val.w, hg_x.z);

	yy = dot(l_val.xyz, vec3(1.0,-2.0,1.0));


	mlf_tc = vec3(0.0);
	muf_tc = vec3(0.0);
	mln_tc = vec3(0.0);
	mun_tc = vec3(0.0);
	lmf_tc = vec3(0.0);
	rmf_tc = vec3(0.0);
	lmn_tc = vec3(0.0);
	rmn_tc = vec3(0.0);

	//__________________________
	//Hesse zz
	// left/right upper/lower near/far
	r_val = vec4(0.0);
	m_val = vec4(0.0);
	l_val = vec4(0.0);
	f_val = vec4(0.0);
	n_val = vec4(0.0);

	vec3 llm_tc = coord - vec3((hg_x.x/size_source.x), 0.0, 0.0);
	vec3 rlm_tc = coord + vec3((hg_x.y/size_source.x), 0.0, 0.0);
              
		 llm_tc = llm_tc - vec3(0.0, (hg_y.x/size_source.y), 0.0);
		 rlm_tc = rlm_tc - vec3(0.0, (hg_y.x/size_source.y), 0.0);
	vec3 lum_tc = llm_tc + vec3(0.0, (hg_y.y/size_source.y), 0.0);
	vec3 rum_tc = rlm_tc + vec3(0.0, (hg_y.y/size_source.y), 0.0);

	lln_tc = llm_tc - vec3(0.0, 0.0, 1.0/size_source.z);
	rln_tc = rlm_tc - vec3(0.0, 0.0, 1.0/size_source.z);
	lun_tc = lum_tc - vec3(0.0, 0.0, 1.0/size_source.z);
	run_tc = rum_tc - vec3(0.0, 0.0, 1.0/size_source.z);
	llf_tc = llm_tc + vec3(0.0, 0.0, 1.0/size_source.z);
	rlf_tc = rlm_tc + vec3(0.0, 0.0, 1.0/size_source.z);
	luf_tc = lum_tc + vec3(0.0, 0.0, 1.0/size_source.z);
	ruf_tc = rum_tc + vec3(0.0, 0.0, 1.0/size_source.z);

	l_val.x = texture( colorTexture, lln_tc).w;
	l_val.y = texture( colorTexture, rln_tc).w;
	l_val.z = texture( colorTexture, lun_tc).w;
	l_val.w = texture( colorTexture, run_tc).w;

	m_val.x = texture( colorTexture, llm_tc).w;
	m_val.y = texture( colorTexture, rlm_tc).w;
	m_val.z = texture( colorTexture, lum_tc).w;
	m_val.w = texture( colorTexture, rum_tc).w;
	
	f_val.x = texture( colorTexture, llf_tc).w;
	f_val.y = texture( colorTexture, rlf_tc).w;
	f_val.z = texture( colorTexture, luf_tc).w;
	f_val.w = texture( colorTexture, ruf_tc).w;

	l_val.zw = lerp(l_val.xy, l_val.zw, hg_y.z);
	m_val.zw = lerp(m_val.xy, m_val.zw, hg_y.z);
	f_val.zw = lerp(r_val.xy, r_val.zw, hg_y.z);

	l_val.x = lerp(l_val.z, l_val.w, hg_x.z);
	l_val.y = lerp(m_val.z, m_val.w, hg_x.z);
	l_val.z = lerp(r_val.z, r_val.w, hg_x.z);

	zz = dot(l_val.xyz, vec3(1.0,-2.0,1.0));


	//__________________________
	//Hesse xy
	// setup texture coordinate
	// left/right upper/lower near/far
	mlf_tc = vec3(0.0);	muf_tc = vec3(0.0);	mln_tc = vec3(0.0);	mun_tc = vec3(0.0);	lmf_tc = vec3(0.0);	rmf_tc = vec3(0.0);	lmn_tc = vec3(0.0);	rmn_tc = vec3(0.0);	llm_tc = vec3(0.0);	rlm_tc = vec3(0.0); lum_tc = vec3(0.0);	rum_tc = vec3(0.0);
	vec4 hg_x2 = hg_x_dev;
	vec4 hg_y2 = hg_y_dev;
	vec4 hg_z2 = hg_z;

	r_val = vec4(0.0);
	m_val = vec4(0.0);
	l_val = vec4(0.0);
	f_val = vec4(0.0);
	n_val = vec4(0.0);

	llf_tc = coord - vec3((hg_x2.x/size_source.x), 0.0, 0.0);
	rlf_tc = coord + vec3((hg_x2.y/size_source.x), 0.0, 0.0);
              
	luf_tc = llf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	ruf_tc = rlf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	llf_tc = llf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
	rlf_tc = rlf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
              
	lun_tc = luf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	run_tc = ruf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	lln_tc = llf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	rln_tc = rlf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	luf_tc = luf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	ruf_tc = ruf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	llf_tc = llf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	rlf_tc = rlf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));

	// read values (2 indirections)
	n_val.x = texture( colorTexture, lun_tc).w;
	n_val.y = texture( colorTexture, run_tc).w;
	n_val.z = texture( colorTexture, lln_tc).w;
	n_val.w = texture( colorTexture, rln_tc).w;
	f_val.x = texture( colorTexture, luf_tc).w;
	f_val.y = texture( colorTexture, ruf_tc).w;
	f_val.z = texture( colorTexture, llf_tc).w;
	f_val.w = texture( colorTexture, rlf_tc).w;

	// output derivative in x direction
	f_val = lerp(n_val, f_val, hg_z.z);
	f_val.zw = (f_val.zw - f_val.xy) * hg_y.z;
	xy = (f_val.w - f_val.z) * hg_x.z;


	//__________________________
	//Hesse xz
	// setup texture coordinate
	// left/right upper/lower near/far
	mlf_tc = vec3(0.0);	muf_tc = vec3(0.0);	mln_tc = vec3(0.0);	mun_tc = vec3(0.0);	lmf_tc = vec3(0.0);	rmf_tc = vec3(0.0);	lmn_tc = vec3(0.0);	rmn_tc = vec3(0.0);	llm_tc = vec3(0.0);	rlm_tc = vec3(0.0);	lum_tc = vec3(0.0);	rum_tc = vec3(0.0);
	hg_x2 = hg_x_dev;
	hg_y2 = hg_y;
	hg_z2 = hg_z_dev;

	r_val = vec4(0.0);
	m_val = vec4(0.0);
	l_val = vec4(0.0);
	f_val = vec4(0.0);
	n_val = vec4(0.0);

	llf_tc = coord - vec3((hg_x2.x/size_source.x), 0.0, 0.0);
	rlf_tc = coord + vec3((hg_x2.y/size_source.x), 0.0, 0.0);
              
	luf_tc = llf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	ruf_tc = rlf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	llf_tc = llf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
	rlf_tc = rlf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
              
	lun_tc = luf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	run_tc = ruf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	lln_tc = llf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	rln_tc = rlf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	luf_tc = luf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	ruf_tc = ruf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	llf_tc = llf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	rlf_tc = rlf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));

	// read values (2 indirections)
	n_val.x = texture(colorTexture, lun_tc).w;
	n_val.y = texture(colorTexture, run_tc).w;
	n_val.z = texture(colorTexture, lln_tc).w;
	n_val.w = texture(colorTexture, rln_tc).w;
	f_val.x = texture(colorTexture, luf_tc).w;
	f_val.y = texture(colorTexture, ruf_tc).w;
	f_val.z = texture(colorTexture, llf_tc).w;
	f_val.w = texture(colorTexture, rlf_tc).w;

	// output derivative in x direction
	f_val = (f_val - n_val) * hg_z.z;
	f_val.zw = lerp(f_val.xy, f_val.zw, hg_y.z);
	xz = (f_val.w - f_val.z) * hg_x.z;


	//__________________________
	//Hesse yz
	// setup texture coordinate
	// left/right upper/lower near/far
	mlf_tc = vec3(0.0);	muf_tc = vec3(0.0);	mln_tc = vec3(0.0);	mun_tc = vec3(0.0);	lmf_tc = vec3(0.0);	rmf_tc = vec3(0.0);	lmn_tc = vec3(0.0);	rmn_tc = vec3(0.0);	llm_tc = vec3(0.0);	rlm_tc = vec3(0.0);	lum_tc = vec3(0.0);	rum_tc = vec3(0.0);
	hg_x2 = hg_x;
	hg_y2 = hg_y_dev;
	hg_z2 = hg_z_dev;

	r_val = vec4(0.0);	m_val = vec4(0.0);	l_val = vec4(0.0);	f_val = vec4(0.0);	n_val = vec4(0.0);

	llf_tc = coord - vec3((hg_x2.x/size_source.x), 0.0, 0.0);
	rlf_tc = coord + vec3((hg_x2.y/size_source.x), 0.0, 0.0);
              
	luf_tc = llf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	ruf_tc = rlf_tc - vec3(0.0, (hg_y2.x/size_source.y), 0.0);
	llf_tc = llf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
	rlf_tc = rlf_tc + vec3(0.0, (hg_y2.y/size_source.y), 0.0);
              
	lun_tc = luf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	run_tc = ruf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	lln_tc = llf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	rln_tc = rlf_tc - vec3(0.0, 0.0, (hg_z2.x/size_source.z));
	luf_tc = luf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	ruf_tc = ruf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	llf_tc = llf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));
	rlf_tc = rlf_tc + vec3(0.0, 0.0, (hg_z2.y/size_source.z));

	// read values (2 indirections)
	n_val.x = texture(colorTexture, lun_tc).w;
	n_val.y = texture(colorTexture, run_tc).w;
	n_val.z = texture(colorTexture, lln_tc).w;
	n_val.w = texture(colorTexture, rln_tc).w;
	f_val.x = texture(colorTexture, luf_tc).w;
	f_val.y = texture(colorTexture, ruf_tc).w;
	f_val.z = texture(colorTexture, llf_tc).w;
	f_val.w = texture(colorTexture, rlf_tc).w;

	// output derivative in y direction
	f_val = (f_val - n_val) * hg_z.z;
	f_val.zw = (f_val.zw - f_val.xy) * hg_y.z;
	yz = lerp(f_val.z, f_val.w, hg_x.z);

	return mat3( xx, xy, xz,	xy, yy, yz,		xz, yz, zz);
}


//coord = texture coordinate
//size_source = 3d Texture Gre
float calculateVoxel(vec3 coord, vec3 size_source )
{
	//vec3 coord_hg = (coord*size_source) - vec3(0.5, 0.5, 0.5);
	vec3 coord_hg = coord + vec3(0.5/size_source.x, 0.5/size_source.y, 0.5/size_source.z);

	// fetch offsets and weights from filter texture
	vec4 hg_x = texture( tex_hg, coord_hg.x );
	vec4 hg_y = texture( tex_hg, coord_hg.y );
	vec4 hg_z = texture( tex_hg, coord_hg.z );

	vec3 s = size_source;
	//vec3 s = vec3(size_source.x/10.0, size_source.y/10.0, size_source.z/10.0);

	// determine linear sampling coordinates
	vec3 coord_source000 = coord - vec3((hg_x.x/s.x), 0.0, 0.0);
	vec3 coord_source100 = coord + vec3((hg_x.y/s.x), 0.0, 0.0);

	vec3 coord_source110 = coord_source100 - vec3(0.0, (hg_y.x/s.y), 0.0);
	vec3 coord_source010 = coord_source000 - vec3(0.0, (hg_y.x/s.y), 0.0);
	     coord_source100 = coord_source100 + vec3(0.0, (hg_y.y/s.y), 0.0);
	     coord_source000 = coord_source000 + vec3(0.0, (hg_y.y/s.y), 0.0);

	vec3 coord_source111 = coord_source110 - vec3(0.0, 0.0, (hg_z.x/s.z));
	vec3 coord_source011 = coord_source010 - vec3(0.0, 0.0, (hg_z.x/s.z));
	vec3 coord_source101 = coord_source100 - vec3(0.0, 0.0, (hg_z.x/s.z));
	vec3 coord_source001 = coord_source000 - vec3(0.0, 0.0, (hg_z.x/s.z));
	     coord_source110 = coord_source110 + vec3(0.0, 0.0, (hg_z.y/s.z));
	     coord_source010 = coord_source010 + vec3(0.0, 0.0, (hg_z.y/s.z));
	     coord_source100 = coord_source100 + vec3(0.0, 0.0, (hg_z.y/s.z));
	     coord_source000 = coord_source000 + vec3(0.0, 0.0, (hg_z.y/s.z));


	//ab da sollte es wieder stimmen
	// fetch four linearly interpolated inputs
	vec4 n_val = vec4(0.0);
	n_val.z = texture( colorTexture, coord_source001).w;
	n_val.w = texture( colorTexture, coord_source101).w;
	n_val.x = texture( colorTexture, coord_source011).w;
	n_val.y = texture( colorTexture, coord_source111).w;

	vec4 f_val = vec4(0.0);
	f_val.z = texture( colorTexture, coord_source000).w;
	f_val.w = texture( colorTexture, coord_source100).w;
	f_val.x = texture( colorTexture, coord_source010).w;
	f_val.y = texture( colorTexture, coord_source110).w;

	// weight along z direction
	f_val 	 = lerp(n_val,		f_val,		hg_z.z );
	f_val.xy = lerp(f_val.zw,	f_val.xy,	hg_y.z );
	return	   lerp(f_val.x,	f_val.y,	hg_x.z );
}

float calcGrad(vec4 hg_x, vec4 hg_y, vec4 hg_z, int type, vec3 coord, vec3 size_source)
{
	vec3 coord_source100 = coord - vec3((hg_x.x/size_source.x),0.0,0.0);
	vec3 coord_source000 = coord + vec3((hg_x.y/size_source.x),0.0,0.0);

	vec3 coord_source110 = coord_source100 - vec3(0.0, (hg_y.x/size_source.y), 0.0);
	vec3 coord_source010 = coord_source000 - vec3(0.0, (hg_y.x/size_source.y), 0.0);
	     coord_source100 = coord_source100 + vec3(0.0, (hg_y.y/size_source.y), 0.0);
	     coord_source000 = coord_source000 + vec3(0.0, (hg_y.y/size_source.y), 0.0);

	vec3 coord_source111 = coord_source110 - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	vec3 coord_source011 = coord_source010 - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	vec3 coord_source101 = coord_source100 - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	vec3 coord_source001 = coord_source000 - vec3(0.0, 0.0, (hg_z.x/size_source.z));
	     coord_source110 = coord_source110 + vec3(0.0, 0.0, (hg_z.y/size_source.z));
	     coord_source010 = coord_source010 + vec3(0.0, 0.0, (hg_z.y/size_source.z));
	     coord_source100 = coord_source100 + vec3(0.0, 0.0, (hg_z.y/size_source.z));
	     coord_source000 = coord_source000 + vec3(0.0, 0.0, (hg_z.y/size_source.z));


	//ab da sollte es wieder stimmen
	// fetch four linearly interpolated inputs
	vec4 n_val;
	n_val.z = texture( colorTexture, coord_source001).w;
	n_val.w = texture( colorTexture, coord_source101).w;
	n_val.x = texture( colorTexture, coord_source011).w;
	n_val.y = texture( colorTexture, coord_source111).w;

	vec4 f_val;
	f_val.z = texture( colorTexture, coord_source000).w;
	f_val.w = texture( colorTexture, coord_source100).w;
	f_val.x = texture( colorTexture, coord_source010).w;
	f_val.y = texture( colorTexture, coord_source110).w;

	float gradient = 0.0;

	// weight along z direction	
	switch(type)
	{
	case 0: 
		f_val		= lerp(n_val, f_val, hg_z.z);
		f_val.zw	= lerp(f_val.xy, f_val.zw, hg_y.z);
		gradient	= (f_val.w - f_val.z)*hg_x.z;
	break;
	case 1:	
		f_val		= lerp(n_val, f_val, hg_z.z);	
		f_val.zw	= (f_val.xy-f_val.zw)*hg_y.z;		
		gradient	= lerp(f_val.z, f_val.w, hg_x.z);
	break;
	case 2:	
		f_val		= (f_val-n_val)*hg_z.z;
		f_val.zw	= lerp(f_val.xy, f_val.zw, hg_y.z);
		gradient	= lerp(f_val.z, f_val.w, hg_x.z);	
	break;
	}

	return gradient;
}

//VOm Assembercode...
vec3 calculateGradient(vec3 coord, vec3 size_source )
{
	//kann dann 1zu1 fr cuda genommen werden (beides bentzt normalisierte Texturekoordinaten)
	// calc filter texture coordinates where [0,1] is a single texel
	// (can be done in vertex program instead)
	//Es ist ja nur der Nachkommabereich interessant von den Texturkoordinaten [0,128]
	//Nachdem ich GL_REPEAT bei der Textur habe, sollte es passen.

//vec3 coord_hg = (coord*size_source) - vec3(0.5f, 0.5f, 0.5f);
vec3 coord_hg = (coord) + (vec3(0.5f, 0.5f, 0.5f)/size_source);

	// fetch offsets and weights from filter texture
	vec4 hg_x = texture( tex_hg, coord_hg.x);
	vec4 hg_y = texture( tex_hg, coord_hg.y);
	vec4 hg_z = texture( tex_hg, coord_hg.z);

	vec4 hg_x_dev = texture(tex_hg_dev, coord_hg.x);
	vec4 hg_y_dev = texture(tex_hg_dev, coord_hg.y);
	vec4 hg_z_dev = texture(tex_hg_dev, coord_hg.z);

	vec3 gradient;
	gradient.x = calcGrad(hg_x_dev, hg_y, hg_z, 0, coord, size_source);
	gradient.y = calcGrad(hg_x, hg_y_dev, hg_z, 1, coord, size_source);
	gradient.z = calcGrad(hg_x, hg_y, hg_z_dev, 2, coord, size_source);
	
	//gradient = (view * vec4(gradient, 0.0)).xyz;

	//the principal curvature directions are easily found as eigenvectors of G.
	return (gradient+vec3(0.0,0.0,0.0))*2.0;
}

float det(mat3 mat) 
{
	return	(mat[0][0] * mat[1][1] * mat[2][2]) + (mat[0][1] * mat[1][2] * mat[2][0]) + (mat[0][2] * mat[1][0] * mat[2][1]) - 
			(mat[0][2] * mat[1][1] * mat[2][0]) - (mat[0][1] * mat[1][0] * mat[2][2]) - (mat[0][0] * mat[1][2] * mat[2][1]);
}

mat3 adjugate(mat3 mat) 
{
	mat3 mat2;
	mat2[0][0] = (mat[1][1]*mat[2][2])-(mat[1][2]*mat[2][1]);
	mat2[0][1] =-(mat[0][1]*mat[2][2])-(mat[0][2]*mat[2][1]);
	mat2[0][2] = (mat[0][1]*mat[1][2])-(mat[0][2]*mat[1][1]);

	mat2[1][0] =-(mat[1][0]*mat[2][2])-(mat[1][2]*mat[2][0]);
	mat2[1][1] = (mat[0][0]*mat[2][2])-(mat[0][2]*mat[2][0]);
	mat2[1][2] =-(mat[0][0]*mat[1][2])-(mat[0][2]*mat[1][0]);

	mat2[2][0] = (mat[1][0]*mat[2][1])-(mat[1][1]*mat[2][0]);
	mat2[2][1] =-(mat[0][0]*mat[2][1])-(mat[0][1]*mat[2][0]);
	mat2[2][2] = (mat[0][0]*mat[1][1])-(mat[0][1]*mat[1][0]);
	return mat2;
}

mat3 inverse(mat3 mat)
{
	float d = det(mat);
	mat3 adj = adjugate(mat);
	adj = adj/d;
	return adj;
}

vec3 calculatePCD(vec3 point)
{
	vec3 g = -calculateGradient(point, vec3(128.0));
	float lengthg = length(g);
	vec3 n = -g/lengthg;	
	
	mat3 pn;	pn[0][0] = n.x;	pn[0][1] = n.y;	pn[0][2] = n.z;
	mat3 P = mat3(1.0) - (pn*transpose(pn)); //sicher richtig (daher sollte der rest auch passen :)
	mat3 H = calcHesse(point, vec3(128.0));
	mat3 G = (P*H*P)/-lengthg;
	
	float T = G[0][0] + G[1][1];// + G[2][2];	
	
	float F = 0.0;	
	/*	
	for(int i = 0; i < 3; i++)	for(int j = 0; j < 3; j++)		F += G[i][j]*G[i][j];	//http://en.wikipedia.org/wiki/Matrix_norm#Frobenius_norm
	/*/
	mat3 tmpf = G * transpose(G);
	F = tmpf[0][0] + tmpf[1][1];// + tmpf[2][2];//*/
	F = sqrt(F);

	float tmp = sqrt((2.0*F*F) - (T*T));
	float kappa1 = (T + tmp) / 2.0;
	float kappa2 = (T - tmp) / 2.0;

	vec3 kappa = vec3(kappa1, kappa2, 0.0);
/*	kappa = abs(kappa);
	return kappa;
/*/
	mat3 tmp2 = G - mat3(kappa1, 0.0, 0.0, 0.0, kappa2, 0.0, 0.0, 0.0, 0.0);
	//mat3 tmp3 = inverse(transpose(tmp2)*tmp2)*transpose(tmp2);
	//mat3 tmp3 = transpose(tmp2);
	mat3 tmp3 = inverse(tmp2);

	//tmp3 = transpose(tmp3);
	vec3 tmp4;
	if((kappa1) > (kappa2))	tmp4 = vec3(tmp3[0][0], tmp3[0][1], tmp3[0][2]);
	else					tmp4 = vec3(tmp3[1][0], tmp3[1][1], tmp3[1][2]);
	tmp4 = vec3(tmp3[0][0], tmp3[1][0], tmp3[2][0]);
	return normalize(tmp4);
//*/
}

//phong lightening
vec3 lightening(vec3 n, vec3 viewDir, vec3 color)
{
	vec3 normal = normalize(n);
	vec3 lightColor = vec3(1.0, 1.0, 1.0);
	vec3 ambientColor = vec3(0.1, 0.1, 0.1);
	vec3 diffuseColor = vec3(0.8, 0.8, 0.8);
	
	vec3 lightDir = viewDir;
	vec3 highlightDir = normalize(lightDir + viewDir);
	float specExponent = 0.5; //je groesser der exponent desto kleiner der glanzpunkt desto glatter ist die oberflche
	
	vec3 ambient = ambientColor * color;
	vec3 diffuse = diffuseColor * min(1.0, max(0.0, dot(normal, lightDir))) * color;
	
	vec3 result;
	vec3 specular = 0.5 * lightColor * pow(max(0.0, dot(normal, highlightDir)), specExponent) * color;
	//vec3 specular = color;
	result = min(vec3(1.0), max(vec3(0.0), ambient + diffuse + specular));

	return result;
/*/
	return abs(normalize(n));
//*/
}

vec3 calculateGradients(vec3 point, float dz)
{
/*
	//Gradienten durch Aufruf von calculateVoxel
	dz = 1.0/128.0;

	vec3 sample1 = vec3(0.0, 0.0, 0.0);
	vec3 sample2 = vec3(0.0, 0.0, 0.0);

	sample1.x = calculateVoxel(point.xyz - vec3(dz, 0, 0), vec3(128.0));
	sample1.y = calculateVoxel(point.xyz - vec3(0, dz, 0), vec3(128.0));
	sample1.z = calculateVoxel(point.xyz - vec3(0, 0, dz), vec3(128.0));

	sample2.x = calculateVoxel(point.xyz + vec3(dz, 0, 0), vec3(128.0));
	sample2.y = calculateVoxel(point.xyz + vec3(0, dz, 0), vec3(128.0));
	sample2.z = calculateVoxel(point.xyz + vec3(0, 0, dz), vec3(128.0));
	
	vec3 N = normalize(sample2 - sample1);	
	return N;
/*/
	return -normalize(calculateGradient(point.xyz, vec3(128.0)));	
	//return normalize(texture(colorTexture, point.xyz).xyz);
//*/
}

//Phong shading .... siehe Paper (Capter 3)
float phongIntensity(float distance, float kamb, float kdiff, float kspec, float n, float k1, float k2, vec3 norm, vec3 l, vec3 h)
{
	vec3 normal = normalize(norm);
	return	(kamb)+	(1.0/(k1+(k2*distance))*(kdiff*min(1.0,max(dot(normal, l),0.0))+	(kspec*min(1.0,pow(max(dot(normal, h),0.0),n)))));
}

void averageOrCompositing(in float dz, in vec4 entry_point, in vec4 exit_point, in int maxiter, in vec3 diff, out vec3 pos, out vec4 outcolor)
{
	vec3 point = entry_point.xyz;
	vec3 N;
	vec3 V;

	//vec3 point = exit_point.xyz;
	//diff = -diff;
	
	int dist = maxiter+1;
	
	if (entry_point.w == 0.0) 	discard; //alpha = 0 man sieht nichts!
	else 
	{
		vec4 Result = vec4(0.0, 0.0, 0.0, 0.0);
		for (int i = 0; i < maxiter; i++) 
		{
			vec3 gradient = texture(colorTexture, point).xyz;

			vec3 N2 = calculateGradients(point, dz);
			vec3 V2 = vec3(exit_point - entry_point);

			//vec4 transferred = texture(transferTexture, texture(colorTexture, point).w);

			float gl = 1.0-min(1.0, max(0.0, length(gradient)));
			vec4 transferred = texture(transferTexture, vec2(calculateVoxel(point, vec3(128.0)),  gl));
//transferred.w = 0.1;

			transferred.xyz = lightening(N2, V2, transferred.xyz);
				
			//compositing
			//hier ausklammern					
			Result.xyz += (1.0 - Result.w) * transferred.w * transferred.xyz;
			Result.w += (1.0 - Result.w) * transferred.w;
			
			if(Result.w > 0.2 && i < dist) 
			{
				pos = point;
				dist = i;
			}

			if (Result.w >= 1.0)	
			{
				break;
			}
			
			/*vec3 lightpos = vec3(1.0,0.0,1.0);
			vec3 l =  point-lightpos; // light vector
			vec3 h = normalize(diff + l); // half vector  	
			//float shadingintensity = min(1.0, max(0.0, phongIntensity(length(l), 0.01, 0.5, 0.8, 0.8, 0.3, 0.1, normalize(N2), normalize(l), h)));

			if (Result.w >= 1.0)	
			{
				break;
			}
			*/

			/*vec3 lightDir = V2;
			vec3 highlightDir = normalize(lightDir + V2);
			float specExponent = 0.5;
			float shadingintensity = min(1.0, max(0.0,  pow(max(0.0, dot(normalize(N2), highlightDir)), specExponent)));
			float alpha = pow(min(1.0, max(0.0, length(N2))), pow(1.0*shadingintensity* (1.0-min(1.0,max(0.0,length(entry_point.xyz-point)/1.0)))*(1.0-Result.w),0.8));
			Result.w += (1.0 - Result.w) * transferred.w * min(1.0, max(0.0, alpha*alpha*alpha));
			
			vec4 norm2 = texture(colorTexture, point.xyz);

			if(norm2.w > 0.1)
			{
				vec3 norm = norm2.xyz;
				float alpha_sample = length(texture(transferTexture, length(norm)/sqrt(2.0)))*pow(1.0 - abs(dot(normalize(norm), normalize(diff))),20.0);
				alpha_sample = (transferred.w*0.25) + (alpha_sample*0.75);			
				
				Result.xyz   = ((1.0-alpha_sample) * Result.xyz) + (alpha_sample *transferred.xyz);	
				Result.w   = ((1.0-alpha_sample) * Result.w) + (alpha_sample *((alpha_sample) + (transferred.w*(1.0-alpha_sample))));	
				//Result.xyz += (1.0-Result.w) * transferred.xyz * alpha_sample;
				//Result.w += (1.0-Result.w)*alpha_sample;
			}
				
			if(Result.w > 0.5 && i < dist) 
			{
				pos = point;
				dist = i;
			}
			*/

/*/
			//Result = transferred;
			transferred.xyz = abs(calculatePCD(point));

			Result.xyz += ((1.0 - Result.w) * transferred.w) * transferred.xyz;
			Result.w += (1.0 - Result.w) * transferred.w;
			if (Result.w >= 1.0) break;
				
				
			if (transferred.w >= 0.2) {
				Result.xyz /= Result.w;
				break;
			}
//*/
				
				point += diff;
			}
			
			if(dist > maxiter)	pos = exit_point.xyz;
			Result.xyzw /= Result.w;

			//if(Result.w > 0.3)	Result.xyzw /= Result.w;
			//else					Result.xyzw = vec4(0.0);
			outcolor = Result;
			return;
		}
}

vec4 maximumIntensity(float dz, vec4 entry_point, vec4 exit_point, int maxiter, vec3 diff)
{
	vec3 point = entry_point.xyz;
	vec3 N;
	vec3 V;
	
	if (entry_point.w == 0.0) {
		discard; //alpha = 0 man sieht nichts!
	} else 
	{
		vec4 Result = vec4(0, 0, 0, 0);
		
		for (int i = 0; i < maxiter; i++) 
		{

			//vec4 intensity = vec4(texture(colorTexture, point).w);
			vec4 intensity = vec4(calculateVoxel(point, vec3(128.0)));
			
			if (intensity.x > Result.x) 
			{
				Result = intensity;
				
				if (transfer == 1) {
					vec4 transferred = texture(transferTexture, vec2((Result.x), 0.0));
					Result.xyz = transferred.xyz;
				}
			
				if (light == 1 || adaptive == 1) 
				{	
					N = calculateGradients(point, dz);
					V = vec3(exit_point - entry_point);
					Result.xyz = lightening(normalize(N), V, Result.xyz);

				}
			}
			
			if(adaptive == 1)
			{
				point += (1.0/length(N)/80.0) * V;
			}
			else
			{			
				point += diff;
			}
			if (Result.w >= 1.0) {
				break;
			}
				
		}
		return Result;
	}
}


void main()
{
	float dz = stepSize; //Schrittgre = 1/200
	vec4 entry_point = texture(entryTexture, fragTexCoordVolume);
	vec4 exit_point = texture(exitTexture, fragTexCoordVolume);
	float iterations = distance(entry_point, exit_point)/dz;
	vec3 diff = (exit_point.xyz - entry_point.xyz)/iterations;
	int maxiter = int(floor(iterations));

	float p = 1.0;
	if (mip == 1) 
	{
		out_color = maximumIntensity(dz, entry_point, exit_point, maxiter, diff);
	} 
	else 
	{
		vec3 pos;
		averageOrCompositing(dz, entry_point, exit_point, maxiter, diff, pos, out_color);
		
		
		if( length(exit_point.xyz-entry_point.xyz) > 0.01)
		{
			pos -= 0.5;
			pos *= 2.0;
			pos -= vec3(0.0, 0.0, 2.0);
			vec4 p2 = perspective * view * vec4(pos.x, pos.y, pos.z, 1.0);
			p = p2.z/p2.w;
			p = (p*0.5)+0.5;
		}
	}

	gl_FragDepth = p;
}