#version 330 core
precision mediump float;

// uniform shader-parameters
uniform mat4 perspective;
uniform mat4 view;

// vertex-shader input variables
in vec4 vertex;
in vec3 texCoord;

// vertex-shader output variables (passed to fragment-shader)
out vec3 fragTexCoord;

void main()
{
	// transform vertex down the pipeline
	gl_Position = perspective * view * vertex;
	
	// pass texture coordinate to fragment-shader
    fragTexCoord = texCoord;
}